import 'package:mason_logger/mason_logger.dart';

abstract class Logging {
  static Logger? _instance;

  /// Returns the [Logger] instance.
  /// If [Logger] instance is null, it will create a new instance.
  static Logger get instance => _instance ??= Logger(
        theme: LogTheme(
          success: (message) => green.wrap('🍻 $message'),
        ),
      );

  /// Sets the [Logger] instance.
  static set instance(Logger logger) => _instance = logger;

  void flush() => instance.flush();
}
