import 'package:dart_dokr/src/core/uri_converter.dart';
import 'package:dart_dokr/src/models/name.dart';
import 'package:json_annotation/json_annotation.dart';

part 'config.g.dart';

@JsonSerializable(
  checked: true,
  anyMap: true,
  fieldRename: FieldRename.snake,
  createToJson: false,
  converters: [UriConverter()],
)
class Config {
  const Config({
    required this.dataDir,
    required this.configDir,
    required this.stacksDir,
    required this.envFiles,
    required this.name,
  });

  factory Config.fromJson(Map<dynamic, dynamic> json) => _$ConfigFromJson(json);

  final Uri dataDir;
  final Uri configDir;
  final Uri stacksDir;
  final List<Uri> envFiles;
  final Name name;
}
