import 'package:dart_dokr/src/core/name_template.dart';
import 'package:dart_dokr/src/core/uri_converter.dart';
import 'package:json_annotation/json_annotation.dart';

part 'name.g.dart';

NameTemplate nameTemplateFromString(String template) =>
    NameTemplate.fromString(template);

RegExp nameRegexFromString(String regex) => RegExp(regex);

@JsonSerializable(
  checked: true,
  anyMap: true,
  fieldRename: FieldRename.snake,
  createToJson: false,
  converters: [UriConverter()],
)
class Name {
  const Name({
    required this.template,
    required this.regex,
  });

  factory Name.fromJson(Map<dynamic, dynamic> json) => _$NameFromJson(json);

  @JsonKey(fromJson: nameTemplateFromString)
  final NameTemplate template;

  @JsonKey(fromJson: nameRegexFromString)
  final RegExp regex;
}
